#include <SoftwareSerial.h>
#include <string.h>
#include <ctype.h>
#include <TinyGPS.h>                      // YOU NEED TO INSTALL THIS LIBRARY !!!!!!

SoftwareSerial lcdSerial(6, 7);           // I'm using a software serial port on pins 6 & 7 for the LCD...
TinyGPS gps;                              // Instatinate a gps object
int ledPin = 10;                          // make the LED test pin on PIN 10
int year;
byte month, day, hour, minute, second, hundredths;
unsigned long fix_age;
//------------------------------------------------------------
void setup()  
{
  pinMode(ledPin, OUTPUT);                // Initialize LED pin for output
  attachInterrupt (0, pps, RISING);       // set the interrupt to turn on LED as soon as pulse detected
  
  Serial1.begin(4800);                    // the Micro serial port will be used for GPS communication
  lcdSerial.begin(19200);                 // set the data rate for the SoftwareSerial port
 
  lcdSerial.write (17);                   // turn on LCD backlight
  lcdSerial.write (22);                   // get rid of cursor
  lcdSerial.write (12);                   // Clear screen and wait 6 msec (as per the LCD docs...
  delay (6);
}
//-----------------------------------------------------------
void loop(){                              // run over and over

  if (Serial1.available())    {           //  do we have GPS information?
    int c=Serial1.read();                 //  yes! 
         
     if (gps.encode(c)) {                 //  now parse it up...
       gps.crack_datetime(&year, &month, &day, &hour, &minute, &second, &hundredths, &fix_age);

       lcdSerial.write (128);             //  curser at the first line

       lcdSerial.print ("UTC    ");       //  print out the stuff..
       printDigit (hour);
       lcdSerial.print (":");
       printDigit (minute);
       lcdSerial.print (":");
       
       lcdSerial.write(148);
       
       lcdSerial.print ("Date  ");
       printDigit (month);
       lcdSerial.print ("-");
       printDigit (day);
       lcdSerial.print ("-");
       lcdSerial.print (int(year));
     }
    }
}
//----------------------------------------
void printDigit (int digit) {         //  this routine prints a leading zero
  if (digit < 10)                     //  if needed to keep the numbers nice...
    lcdSerial.print ("0");
  lcdSerial.print (digit);
}
//-----------------------------------------
void pps() {                           // this is called each time the 1 PPS
                                       // pulse that is received 
  digitalWrite (ledPin, HIGH);         // Turn on LED, we have a new second pulse..
    
  second = second + 1;                 // With pulse received, increment the second..
  
  if (second == 60){                   // did we cross into a new minute?
      second = 0;                      // YES? -> reset back to zero
      minute = minute + 1;             //         and increment minutes, also.
      
        if (minute == 60) {            // have we crossed in a new hour?
            minute = 0;                // YES? -> reset minutes to zero
            hour = hour + 1;           //         and increment the hour...
            
            if (hour == 24)            // have we crossed into a new day?
               hour = 0;               // Yes?  -> reset hours to zero

            lcdSerial.write (135);     //  write the new hour (...minutes were reset)
            printDigit (hour);
            }
      lcdSerial.write (138);           //  write the new minutes (...seconds were reset)
      printDigit (minute);
      }
  lcdSerial.write (141);               // write the new second...
  printDigit (second);
  
  digitalWrite (ledPin, LOW);          // turn of the LED...
}
//----------------------------------------
